\usetikzlibrary{
	arrows.meta,
	graphs,
	shapes.misc,
}

\def\branchheight{7mm}

% Based upon `\url{https://tikz.dev/tutorial-chains} (\href{https://tikz.dev/license}{LPP license})`
\begin{tikzpicture}[
	>={Stealth},
	gray,
	text=black,
	thick,
	every new ->/.style={
		{shorten >}=1pt,  % add space in front of arrow head
	},
	% "/" in "graphs/every graph" is used to access namespace
	graphs/every graph/.style={
		edges=rounded corners
	},
	skip loop/.style={
		to path={
			% Create edge with relative y offset,
			% then use continuing extending line horizontally
			% then add arrow pointing to target
			-- ++(0, #1) -| (\tikztotarget)
		},
	},
	% hv = horizontal then vertical
	hv path/.style={
		to path={-| (\tikztotarget)}
	},
	vh path/.style={
		to path={|- (\tikztotarget)}
	},
	nonterminal/.style={
		rectangle,
		minimum size=6mm,
		thick,
		draw=red!50!black!50,
		top color=white,
		bottom color=red!50!black!20,
		font=\itshape,
		text height=1.50ex,
		text depth=0.25ex,
	},
	terminal/.style = {
		rounded rectangle,
		minimum size=6mm,
		thick,
		draw=black!50,
		top color=white,
		bottom color=black!20,
		font=\ttfamily,  % tt = teletype (monospaced font)
		text height=1.50ex,
		text depth=0.25ex,
	},
	shape=coordinate,
]
	\graph[
		grow right sep,
		branch down=\branchheight,
		simple,
	] {
		% A slash prefix disables the automatic naming of nodes
		% (defaults to node text)
		/input[nonterminal]
		-- /
		-> /L[terminal]
		-- p1
		-> /OL[terminal]
		-- p2
		-- p3
		-- p4
		-> [vh path] {
			[nodes={yshift=\branchheight}]
				/?[terminal],
				p5,
				/L[terminal] -- l1,
		}
		-> [hv path] p6
		-> /match[nonterminal];

		p2 ->[skip loop=-\branchheight] p1;
		l1 ->[skip loop=-\branchheight] p3;

		% Override arrow head styles
		p4 -- p5 -- p6;
	};
\end{tikzpicture}
